unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, ComCtrls, Math, Grids;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    Panel2: TPanel;
    ok: TButton;
    Button1: TButton;
    pokazraport: TButton;
    Zamknij: TButton;
    GroupBox4: TGroupBox;
    progress: TProgressBar;
    dopliku: TCheckBox;
    dialog_dopliku: TSaveDialog;
    GroupBox1: TGroupBox;
    algdy: TCheckBox;
    algdo: TCheckBox;
    zapiszwe: TCheckBox;
    nbar: TScrollBar;
    bbar: TScrollBar;
    Label2: TLabel;
    Label3: TLabel;
    bval: TEdit;
    nval: TEdit;
    Dodaj: TButton;
    serien: TStringGrid;
    niezmdanewe: TCheckBox;
    procedure DodajClick(Sender: TObject);
    procedure editnKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure okClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pokazraportClick(Sender: TObject);
    procedure ZamknijClick(Sender: TObject);
    procedure doplikuClick(Sender: TObject);
    procedure serienKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bbarChange(Sender: TObject);
    procedure nbarChange(Sender: TObject);
    procedure nvalKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bvalKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
  end;

type
  TIQ = 110..170;
  Twaga = 80..130;
  intelektualista = record
    iq :TIQ;
    waga :Twaga;
  end;
  intelekty = array of intelektualista;

type plista=^lista;
     lista=record
       v         :Integer;
       klucz     :integer;
       nastepnik :plista;
     end;

function zwolaj_intelektualistow(n :integer) :intelekty;
function algdyn(dane :intelekty; b :integer) :integer;
function algdok(var dane :intelekty; b :integer) :integer; overload;
//function algdok(var dane :intelekty; b :integer; var wziety :array of boolean) :integer; overload;

//listy
function z_listy(var lista :plista) :integer;
procedure do_listy(v :Integer; klucz : integer; var lista :plista);
procedure usun(var l :plista); overload;

// inne
function timetostr(t :TDateTime) :string;
procedure raportuj(v :string; kolumna :integer);

var
  Form1  :TForm1;
  wziety :array of boolean;
  l :plista;

implementation

{$R *.dfm}

  uses Unit2, Unit3;

procedure usun(var l :plista);
var nastepny :plista;
begin
while l<>nil do
  begin
  nastepny := l^.nastepnik;
  Dispose(l);
  l := nastepny;
  end;
l := nil;
end;

procedure do_listy(v :Integer; klucz : integer; var lista :plista);
var nowy, tmp, ost :plista;
begin
 if lista=nil then
    begin
      New(nowy);
      nowy^.v := v;
      nowy^.klucz := klucz;
      nowy^.nastepnik := nil;
      lista := nowy;
    end
  else
    begin
      ost := nil;
      tmp := lista;
      while (tmp<>nil) and (tmp^.v>v) do
        begin
        ost := tmp;
        tmp := tmp^.nastepnik;
        end;
      New(nowy);
      nowy^.v := v;
      nowy^.klucz := klucz;
      if ost<>nil then
        begin
        tmp := ost;
        nowy^.nastepnik := tmp^.nastepnik;
        tmp^.nastepnik := nowy;
        end
      else
        begin
        nowy^.nastepnik := tmp;
        lista := nowy;
        end;
    end
end;

function z_listy(var lista :plista) :integer;
var tmp :plista;
    w :integer;
begin
w := 0;
if lista<>nil then
  begin
    w := lista^.klucz;
    tmp := lista^.nastepnik;
    dispose(lista);
    lista := tmp;
  end;
Result := w;
end;

function algdyn(dane :intelekty; b :integer) :integer;
var i2m, wybrane, ostatecznie, niewyb :plista;
    i,j                               :integer;
    zespol                            :string;
    function v(i :integer) :Integer;
      begin result := round((dane[i].iq / dane[i].waga)*100); end;
begin
i2m := nil; wybrane := nil; ostatecznie := nil; niewyb :=nil;
for i := 0 to High(dane) do // wierzcholki na liste, na poczatku te o max. wspolczynniku iq/masy
  do_listy(v(i), i, i2m);

while i2m<>nil do
  begin
  i := z_listy(i2m); // bierz wierzcholki po kolei
  if (dane[i].waga<=b) then // jesli sa o dopuszczalnej wadze, do wybranych i zmniejsz pozostale miejsce b
    begin
    do_listy(10-v(i), i, wybrane);
    Dec(b, dane[i].waga);
    end
  else do_listy(v(i), i, niewyb); // do listy nie przyjetych
  end;

  // weryfikacja wybranych
while wybrane<>nil do // dla kazdego z wybranych
  begin
  i := z_listy(wybrane);
  i2m := niewyb;
  niewyb := nil;
  while i2m<>nil do // przejzyl na liscie tych ktorzy sie nie dostali
    begin
      j := z_listy(i2m);
      if (dane[j].iq>dane[i].iq) and (dane[j].waga<(dane[i].waga+b)) then // czy jest jakis, ktory lepiej zagospodaruje miejsce wolne b
        begin
        do_listy(v(i), i, niewyb);
        b := b + dane[i].waga - dane[j].waga;
        i := j;
        end
      else
        do_listy(v(j), j, niewyb);
    end;
  do_listy(v(i), i, ostatecznie);
  end;

usun(i2m);

i := 0;
while ostatecznie<>nil do
  begin
  j := z_listy(ostatecznie);
  i := i + dane[j].iq;
  zespol := zespol + inttostr(j) + ',';
  end;
raport.danewe.Lines.Add('algdyn: '+zespol);
Result := i;
end;

function algdok(var dane :intelekty; b :integer) :integer;
var intelekt    :integer;
    intelektMax :integer;
    i           :integer;
begin
intelektMax := 0;
for i := 0 to High(dane) do
  if (not wziety[i]) and (b >= dane[i].waga) then
    begin
    wziety[i] := true;
    intelekt := dane[i].iq + algdok(dane, b-dane[i].waga);
    if intelekt > intelektMax then
      intelektMax := intelekt;
    wziety[i] := false;
    end;
Result := intelektMax;
end;

function zwolaj_intelektualistow(n :integer) :intelekty;
var wynik:intelekty;
    i :integer;
begin
setLength(wynik, n);
for i := 0 to High(wynik) do
  begin
  wynik[i].iq := 110 + random(60);
  wynik[i].waga := 80 + random(50);
  end;
Result := wynik;
end;

// ------------------------------------

procedure TForm1.okClick(Sender: TObject);
var numer_n, n, b, i :integer;
    f                :TextFile;
    dane             :intelekty;
    t                :TDateTime;
begin
try
raport.WyczyscClick(sender);
progress.Max := 4*(serien.RowCount-1);
for numer_n := 1 to serien.RowCount-2 do
  begin
  raport.pomiary.Row:=numer_n;
  raportuj(serien.Cells[2, numer_n], 0);
  raportuj(serien.Cells[3, numer_n], 1);
  b :=strtoint(serien.Cells[2, numer_n]);
  n :=strtoint(serien.Cells[3, numer_n]);

  if (not niezmdanewe.Checked) or (n<>Length(dane)) then
    dane := zwolaj_intelektualistow(n);
  progress.StepIt;

  if zapiszwe.Checked then
    begin
    raport.danewe.Lines.Add('Wyprawa kosmiczna '+inttostr(numer_n)+': n='+inttostr(n)+' b='+inttostr(b));
    for i := 0 to High(dane) do
      raport.danewe.Lines.Add(Format('%-4d iq=%-8d waga=%-8d i/m=%-5.3f', [i, dane[i].iq, dane[i].waga, dane[i].iq/dane[i].waga]));
    end;
  progress.StepIt;

  if algdy.Checked then
    begin
    t := time;
    i := algdyn(dane, b);
    raportuj(timetostr(time-t), 2);
    raportuj(IntToStr(i), 3);
    end;
  progress.StepIt;

  if algdo.Checked then
    begin
    SetLength(wziety, Length(dane));
    for i := 0 to High(wziety) do wziety[i] := false;

    t := time;
    i := algdok(dane, b);
    raportuj(timetostr(time-t), 4);
    raportuj(IntToStr(i), 5);
    end;
  progress.StepIt;

  end;

Finalize(dane);

if form1.dopliku.Checked then
  begin
  {$I+}
  try
  AssignFile(f, form1.dialog_dopliku.FileName);
    try
    Append(f);
    except
    on EInOutError do
      Rewrite(f);
    end;
  for i := 0 to raport.pomiary.RowCount-1 do
    begin
    for n := 0 to raport.pomiary.ColCount-1 do
      write(f, raport.pomiary.cells[n, i]+#09);
    writeln(f);
    end;
  finally
  closefile(f);
  end;
  end;
form1.progress.Position:=0;
pokazraportClick(sender);
except
  on ex :Exception do
    showmessage('Blad: '+ex.Message);
end;
end;

//*********************************
// inne
//*********************************

function timetostr(t :TDateTime) :string;
begin
Result := inttostr(round(t*24*360000));
end;

procedure raportuj(v :string; kolumna :integer);
begin
raport.pomiary.Cells[kolumna, raport.pomiary.Row] :=v;
end;

//*********************************
// interfejs
//*********************************

procedure TForm1.DodajClick(Sender: TObject);
var n :integer;
begin
try
  strtoint(nval.text);
  n := form1.serien.RowCount-1;
  serien.Cells[2, n] := bval.Text;
  serien.Cells[3, n] := nval.Text;  
  if  algdy.Checked then
    serien.Cells[0, n] := 'T'
  else serien.Cells[0, n] := 'N';
  if algdo.Checked then
    serien.Cells[1, n] := 'T'
  else serien.Cells[1, n] := 'N';
  form1.serien.RowCount := form1.serien.RowCount+1  
except
  on EConvertError do
    showmessage('n musi byc liczba!');
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
l := nil;
serien.Cells[0, 0] := 'A.dyn';
serien.Cells[1, 0] := 'A.dok';
serien.Cells[2, 0] := 'b';
serien.Cells[3, 0] := 'n';
randomize;
end;

procedure TForm1.editnKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = vk_return then dodajclick(sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
oprogramie.show;
end;

procedure TForm1.pokazraportClick(Sender: TObject);
begin
raport.Show;
end;

procedure TForm1.ZamknijClick(Sender: TObject);
begin
if messagedlg('Napewno zamkn program?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
application.Terminate;
end;

procedure TForm1.doplikuClick(Sender: TObject);
begin
if dopliku.Checked then
  dopliku.Checked := dialog_dopliku.Execute;
end;

procedure TForm1.serienKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i, j :integer;
begin
if key = vk_delete then
for i := 1 to serien.RowCount-1 do
  for j := 0 to serien.ColCount-1 do
    serien.Cells[j, i] := '';
serien.RowCount := 2;
end;

procedure TForm1.bbarChange(Sender: TObject);
begin
bval.text := inttostr(bbar.Max - bbar.Position);
end;

procedure TForm1.nbarChange(Sender: TObject);
begin
nval.text := inttostr(nbar.Max - nbar.Position);
end;

procedure TForm1.nvalKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  try
    nbar.Position := nbar.Max - strtoint(nval.Text);
  except
    on EConvertError do
      nval.Text := inttostr(nbar.Max - nbar.Position);
  end;
if key = vk_return then
    DodajClick(sender);
end;

procedure TForm1.bvalKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  try
    bbar.Position := bbar.Max - strtoint(bval.Text);
  except
    on EConvertError do
      bval.Text := inttostr(bbar.Max - bbar.Position);
  end;
if key = vk_return then
    DodajClick(sender);
end;

end.
