#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int fibo(int n, int depth) {
  int i;
  if (n>=2) {
    if (fork()==0) fibo(n-2, depth+1);
    if (fork()==0) fibo(n-1, depth+1);
  } else {
    for (i=0; i<=depth; i++) putchar(' ');
    printf("`-%d (pid: %d)\n", n, getpid());
  }
  exit(0);
}

int main(int argc, char *argv[]) {
  int n;
  if (argc<2) {
    fprintf(stderr, "usage: %s n\n", argv[0]); exit(1); 
  }
  n=atoi(argv[1]);
  if (fork()==0)
    fibo(n, 0);
}

