#include <stdio.h>
#include <unistd.h>
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>

void client(int pipe) {
  char c='a';
  while (1) {
    usleep(1000000);
    write(pipe, &c, 1);
  }
}

int main() {
  int retval=0;
  int p[2];
  struct timeval t;
  fd_set set;
  pipe(p);
  if (fork()==0) {
    close(p[0]);
    client(p[1]);
    exit(0);
  }
  FD_ZERO(&set);
  FD_SET(p[0], &set);
  close(p[1]);
  while (retval==0) {
    retval = select(p[0]+1, &set, NULL, NULL, &t);
    t.tv_sec=1; 
    t.tv_usec=0;
  }
  printf("received\n");
  
  return 0;
}
