#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

void galaz(int wysokosc) {
  int c;
  printf("galaz%d %d %d\n", wysokosc, getppid(), getpid());
  fflush(stdout);
  if (wysokosc>1) {
    if ((c=fork())==0) {galaz(wysokosc-1); exit(0); }
    waitpid(c, NULL, 0);
  }
}

void posadz_drzewo(int wysokosc) {
  int c;
  printf("drzewo%d %d %d\n", wysokosc, getppid(), getpid());
  fflush(stdout);
  if (wysokosc>1) {
    if ((c=fork())==0) { galaz(wysokosc-1); exit(0); }
    waitpid(c, NULL, 0);
    if ((c=fork())==0) { galaz(wysokosc-1); exit(0); }
    waitpid(c, NULL, 0);
    if ((c=fork())==0) { galaz(wysokosc-1); exit(0); }
    waitpid(c, NULL, 0);
  }
}

void posadz_zagajnik(int ldrzew) {
  int c;
  printf("zagajnik%d %d %d\n", ldrzew, getppid(), getpid());
  fflush(stdout);
  while (ldrzew>0) {
    if ((c=fork())==0) {posadz_drzewo(ldrzew); exit(0); }
    waitpid(c, NULL, 0);
    ldrzew--;
  }
}

int main(int argc, char *argv[]) {
  int n, d, z;
  if (argc<3) {
    fprintf(stderr, "zalesianie n d\n"
	            "\tn - liczba zagajnikw\n"
	            "\td - liczba drzew w zagajniku\n"
	    );
    return 1;
  }
  n = atoi(argv[1]);
  d = atoi(argv[2]);
  while (n>0) {
    if ((z=fork())==0) {posadz_zagajnik(d); exit(0);}
    waitpid(z, NULL, 0);
    n--;
  }
  return 0;
}
