#include "poczta_dostep.h"

int poczta_otworz(int pocztaid) { /* otworz kolejke do poczty i utworz wlasna kolejke */
  if (((poczta = msgget(pocztaid, 0660)) == -1)||((odp = msgget(IPC_PRIVATE, 0660)) == -1)) {
    perror("msgget(poczta||odp)");
    return FALSE;
  } else
    return TRUE;
}

int poczta_zamknij(void) { /* usun wlasna kolejke */
  if (msgctl(odp, IPC_RMID, 0) == -1) {
    perror("msgctl(odp, rm)");
    return FALSE;
  } else
    return TRUE;
}

int zapytaj(int nadawca, int oper, int arg) { /* przeslij zapytanie i zwroc odpowiedz */
  zapytanie_t wiad = {nadawca, odp, oper, arg};
  if (msgsnd(poczta, &wiad, ROZM_TRESCI, 0) == -1) {
    perror("zapytaj snd");
    return FALSE;
  }
  if (msgrcv(odp, &wiad, ROZM_TRESCI, 0, 0) == -1) {
    perror("zapytaj rcv");
    return FALSE;
  }
  return wiad.numer;
}
